diff --git a/src/backend/executor/execExprInterp.c b/src/backend/executor/execExprInterp.c
index eaec697bb3..fcc2f346bf 100644
--- a/src/backend/executor/execExprInterp.c
+++ b/src/backend/executor/execExprInterp.c
@@ -151,7 +151,7 @@ static Datum ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnul
 static void ExecInitInterpreter(void);
 
 /* support functions */
-static void CheckVarSlotCompatibility(TupleTableSlot *slot, int attnum, Oid vartype);
+static void CheckVarSlotCompatibility(TupleTableSlot *slot, int attphysnum, Oid vartype);
 static void CheckOpSlotCompatibility(ExprEvalStep *op, TupleTableSlot *slot);
 static TupleDesc get_cached_rowtype(Oid type_id, int32 typmod,
 									ExprEvalRowtypeCache *rowcache,
@@ -561,7 +561,7 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 
 		EEO_CASE(EEOP_INNER_VAR)
 		{
-			int			attnum = op->d.var.attnum;
+			int			attphysnum = op->d.var.attphysnum;
 
 			/*
 			 * Since we already extracted all referenced columns from the
@@ -569,35 +569,35 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 			 * directly out of the slot's decomposed-data arrays.  But let's
 			 * have an Assert to check that that did happen.
 			 */
-			Assert(attnum >= 0 && attnum < innerslot->tts_nvalid);
-			*op->resvalue = innerslot->tts_values[attnum];
-			*op->resnull = innerslot->tts_isnull[attnum];
+			Assert(attphysnum >= 0 && attphysnum < innerslot->tts_nvalid);
+			*op->resvalue = innerslot->tts_values[attphysnum];
+			*op->resnull = innerslot->tts_isnull[attphysnum];
 
 			EEO_NEXT();
 		}
 
 		EEO_CASE(EEOP_OUTER_VAR)
 		{
-			int			attnum = op->d.var.attnum;
+			int			attphysnum = op->d.var.attphysnum;
 
 			/* See EEOP_INNER_VAR comments */
 
-			Assert(attnum >= 0 && attnum < outerslot->tts_nvalid);
-			*op->resvalue = outerslot->tts_values[attnum];
-			*op->resnull = outerslot->tts_isnull[attnum];
+			Assert(attphysnum >= 0 && attphysnum < outerslot->tts_nvalid);
+			*op->resvalue = outerslot->tts_values[attphysnum];
+			*op->resnull = outerslot->tts_isnull[attphysnum];
 
 			EEO_NEXT();
 		}
 
 		EEO_CASE(EEOP_SCAN_VAR)
 		{
-			int			attnum = op->d.var.attnum;
+			int			attphysnum = op->d.var.attphysnum;
 
 			/* See EEOP_INNER_VAR comments */
 
-			Assert(attnum >= 0 && attnum < scanslot->tts_nvalid);
-			*op->resvalue = scanslot->tts_values[attnum];
-			*op->resnull = scanslot->tts_isnull[attnum];
+			Assert(attphysnum >= 0 && attphysnum < scanslot->tts_nvalid);
+			*op->resvalue = scanslot->tts_values[attphysnum];
+			*op->resnull = scanslot->tts_isnull[attphysnum];
 
 			EEO_NEXT();
 		}
@@ -631,16 +631,16 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 		EEO_CASE(EEOP_ASSIGN_INNER_VAR)
 		{
 			int			resultnum = op->d.assign_var.resultnum;
-			int			attnum = op->d.assign_var.attnum;
+			int			attphysnum = op->d.assign_var.attphysnum;
 
 			/*
 			 * We do not need CheckVarSlotCompatibility here; that was taken
 			 * care of at compilation time.  But see EEOP_INNER_VAR comments.
 			 */
-			Assert(attnum >= 0 && attnum < innerslot->tts_nvalid);
+			Assert(attphysnum >= 0 && attphysnum < innerslot->tts_nvalid);
 			Assert(resultnum >= 0 && resultnum < resultslot->tts_tupleDescriptor->natts);
-			resultslot->tts_values[resultnum] = innerslot->tts_values[attnum];
-			resultslot->tts_isnull[resultnum] = innerslot->tts_isnull[attnum];
+			resultslot->tts_values[resultnum] = innerslot->tts_values[attphysnum];
+			resultslot->tts_isnull[resultnum] = innerslot->tts_isnull[attphysnum];
 
 			EEO_NEXT();
 		}
@@ -648,16 +648,16 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 		EEO_CASE(EEOP_ASSIGN_OUTER_VAR)
 		{
 			int			resultnum = op->d.assign_var.resultnum;
-			int			attnum = op->d.assign_var.attnum;
+			int			attphysnum = op->d.assign_var.attphysnum;
 
 			/*
 			 * We do not need CheckVarSlotCompatibility here; that was taken
 			 * care of at compilation time.  But see EEOP_INNER_VAR comments.
 			 */
-			Assert(attnum >= 0 && attnum < outerslot->tts_nvalid);
+			Assert(attphysnum >= 0 && attphysnum < outerslot->tts_nvalid);
 			Assert(resultnum >= 0 && resultnum < resultslot->tts_tupleDescriptor->natts);
-			resultslot->tts_values[resultnum] = outerslot->tts_values[attnum];
-			resultslot->tts_isnull[resultnum] = outerslot->tts_isnull[attnum];
+			resultslot->tts_values[resultnum] = outerslot->tts_values[attphysnum];
+			resultslot->tts_isnull[resultnum] = outerslot->tts_isnull[attphysnum];
 
 			EEO_NEXT();
 		}
@@ -665,16 +665,16 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 		EEO_CASE(EEOP_ASSIGN_SCAN_VAR)
 		{
 			int			resultnum = op->d.assign_var.resultnum;
-			int			attnum = op->d.assign_var.attnum;
+			int			attphysnum = op->d.assign_var.attphysnum;
 
 			/*
 			 * We do not need CheckVarSlotCompatibility here; that was taken
 			 * care of at compilation time.  But see EEOP_INNER_VAR comments.
 			 */
-			Assert(attnum >= 0 && attnum < scanslot->tts_nvalid);
+			Assert(attphysnum >= 0 && attphysnum < scanslot->tts_nvalid);
 			Assert(resultnum >= 0 && resultnum < resultslot->tts_tupleDescriptor->natts);
-			resultslot->tts_values[resultnum] = scanslot->tts_values[attnum];
-			resultslot->tts_isnull[resultnum] = scanslot->tts_isnull[attnum];
+			resultslot->tts_values[resultnum] = scanslot->tts_values[attphysnum];
+			resultslot->tts_isnull[resultnum] = scanslot->tts_isnull[attphysnum];
 
 			EEO_NEXT();
 		}
@@ -1879,25 +1879,25 @@ CheckExprStillValid(ExprState *state, ExprContext *econtext)
 		{
 			case EEOP_INNER_VAR:
 				{
-					int			attnum = op->d.var.attnum;
+					int			attphysnum = op->d.var.attphysnum;
 
-					CheckVarSlotCompatibility(innerslot, attnum + 1, op->d.var.vartype);
+					CheckVarSlotCompatibility(innerslot, attphysnum + 1, op->d.var.vartype);
 					break;
 				}
 
 			case EEOP_OUTER_VAR:
 				{
-					int			attnum = op->d.var.attnum;
+					int			attphysnum = op->d.var.attphysnum;
 
-					CheckVarSlotCompatibility(outerslot, attnum + 1, op->d.var.vartype);
+					CheckVarSlotCompatibility(outerslot, attphysnum + 1, op->d.var.vartype);
 					break;
 				}
 
 			case EEOP_SCAN_VAR:
 				{
-					int			attnum = op->d.var.attnum;
+					int			attphysnum = op->d.var.attphysnum;
 
-					CheckVarSlotCompatibility(scanslot, attnum + 1, op->d.var.vartype);
+					CheckVarSlotCompatibility(scanslot, attphysnum + 1, op->d.var.vartype);
 					break;
 				}
 			default:
@@ -1912,7 +1912,7 @@ CheckExprStillValid(ExprState *state, ExprContext *econtext)
  * since the expression tree has been created.
  */
 static void
-CheckVarSlotCompatibility(TupleTableSlot *slot, int attnum, Oid vartype)
+CheckVarSlotCompatibility(TupleTableSlot *slot, int attphysnum, Oid vartype)
 {
 	/*
 	 * What we have to check for here is the possibility of an attribute
@@ -1931,28 +1931,28 @@ CheckVarSlotCompatibility(TupleTableSlot *slot, int attnum, Oid vartype)
 	 * System attributes don't require checking since their types never
 	 * change.
 	 */
-	if (attnum > 0)
+	if (attphysnum > 0)
 	{
 		TupleDesc	slot_tupdesc = slot->tts_tupleDescriptor;
 		Form_pg_attribute attr;
 
-		if (attnum > slot_tupdesc->natts)	/* should never happen */
+		if (attphysnum > slot_tupdesc->natts)	/* should never happen */
 			elog(ERROR, "attribute number %d exceeds number of columns %d",
-				 attnum, slot_tupdesc->natts);
+				 attphysnum, slot_tupdesc->natts);
 
-		attr = TupleDescAttr(slot_tupdesc, attnum - 1);
+		attr = TupleDescAttr(slot_tupdesc, attphysnum - 1);
 
 		if (attr->attisdropped)
 			ereport(ERROR,
 					(errcode(ERRCODE_UNDEFINED_COLUMN),
 					 errmsg("attribute %d of type %s has been dropped",
-							attnum, format_type_be(slot_tupdesc->tdtypeid))));
+							attphysnum, format_type_be(slot_tupdesc->tdtypeid))));
 
 		if (vartype != attr->atttypid)
 			ereport(ERROR,
 					(errcode(ERRCODE_DATATYPE_MISMATCH),
 					 errmsg("attribute %d of type %s has wrong type",
-							attnum, format_type_be(slot_tupdesc->tdtypeid)),
+							attphysnum, format_type_be(slot_tupdesc->tdtypeid)),
 					 errdetail("Table has type %s, but query expects %s.",
 							   format_type_be(attr->atttypid),
 							   format_type_be(vartype))));
@@ -2078,16 +2078,16 @@ static pg_attribute_always_inline Datum
 ExecJustVarImpl(ExprState *state, TupleTableSlot *slot, bool *isnull)
 {
 	ExprEvalStep *op = &state->steps[1];
-	int			attnum = op->d.var.attnum + 1;
+	int			attphysnum = op->d.var.attphysnum + 1;
 
 	CheckOpSlotCompatibility(&state->steps[0], slot);
 
 	/*
 	 * Since we use slot_getattr(), we don't need to implement the FETCHSOME
-	 * step explicitly, and we also needn't Assert that the attnum is in range
+	 * step explicitly, and we also needn't Assert that the attphysnum is in range
 	 * --- slot_getattr() will take care of any problems.
 	 */
-	return slot_getattr(slot, attnum, isnull);
+	return slot_getattr(slot, attphysnum, isnull);
 }
 
 /* Simple reference to inner Var */
@@ -2116,7 +2116,7 @@ static pg_attribute_always_inline Datum
 ExecJustAssignVarImpl(ExprState *state, TupleTableSlot *inslot, bool *isnull)
 {
 	ExprEvalStep *op = &state->steps[1];
-	int			attnum = op->d.assign_var.attnum + 1;
+	int			attphysnum = op->d.assign_var.attphysnum + 1;
 	int			resultnum = op->d.assign_var.resultnum;
 	TupleTableSlot *outslot = state->resultslot;
 
@@ -2127,13 +2127,13 @@ ExecJustAssignVarImpl(ExprState *state, TupleTableSlot *inslot, bool *isnull)
 	 * at compilation time.
 	 *
 	 * Since we use slot_getattr(), we don't need to implement the FETCHSOME
-	 * step explicitly, and we also needn't Assert that the attnum is in range
+	 * step explicitly, and we also needn't Assert that the attphysnum is in range
 	 * --- slot_getattr() will take care of any problems.  Nonetheless, check
 	 * that resultnum is in range.
 	 */
 	Assert(resultnum >= 0 && resultnum < outslot->tts_tupleDescriptor->natts);
 	outslot->tts_values[resultnum] =
-		slot_getattr(inslot, attnum, &outslot->tts_isnull[resultnum]);
+		slot_getattr(inslot, attphysnum, &outslot->tts_isnull[resultnum]);
 	return 0;
 }
 
@@ -2211,7 +2211,7 @@ static pg_attribute_always_inline Datum
 ExecJustVarVirtImpl(ExprState *state, TupleTableSlot *slot, bool *isnull)
 {
 	ExprEvalStep *op = &state->steps[0];
-	int			attnum = op->d.var.attnum;
+	int			attphysnum = op->d.var.attphysnum;
 
 	/*
 	 * As it is guaranteed that a virtual slot is used, there never is a need
@@ -2221,11 +2221,11 @@ ExecJustVarVirtImpl(ExprState *state, TupleTableSlot *slot, bool *isnull)
 	 */
 	Assert(TTS_IS_VIRTUAL(slot));
 	Assert(TTS_FIXED(slot));
-	Assert(attnum >= 0 && attnum < slot->tts_nvalid);
+	Assert(attphysnum >= 0 && attphysnum < slot->tts_nvalid);
 
-	*isnull = slot->tts_isnull[attnum];
+	*isnull = slot->tts_isnull[attphysnum];
 
-	return slot->tts_values[attnum];
+	return slot->tts_values[attphysnum];
 }
 
 /* Like ExecJustInnerVar, optimized for virtual slots */
@@ -2254,7 +2254,7 @@ static pg_attribute_always_inline Datum
 ExecJustAssignVarVirtImpl(ExprState *state, TupleTableSlot *inslot, bool *isnull)
 {
 	ExprEvalStep *op = &state->steps[0];
-	int			attnum = op->d.assign_var.attnum;
+	int			attphysnum = op->d.assign_var.attphysnum;
 	int			resultnum = op->d.assign_var.resultnum;
 	TupleTableSlot *outslot = state->resultslot;
 
@@ -2262,11 +2262,11 @@ ExecJustAssignVarVirtImpl(ExprState *state, TupleTableSlot *inslot, bool *isnull
 
 	Assert(TTS_IS_VIRTUAL(inslot));
 	Assert(TTS_FIXED(inslot));
-	Assert(attnum >= 0 && attnum < inslot->tts_nvalid);
+	Assert(attphysnum >= 0 && attphysnum < inslot->tts_nvalid);
 	Assert(resultnum >= 0 && resultnum < outslot->tts_tupleDescriptor->natts);
 
-	outslot->tts_values[resultnum] = inslot->tts_values[attnum];
-	outslot->tts_isnull[resultnum] = inslot->tts_isnull[attnum];
+	outslot->tts_values[resultnum] = inslot->tts_values[attphysnum];
+	outslot->tts_isnull[resultnum] = inslot->tts_isnull[attphysnum];
 
 	return 0;
 }
@@ -4036,11 +4036,11 @@ ExecEvalGroupingFunc(ExprState *state, ExprEvalStep *op)
 
 	foreach(lc, op->d.grouping_func.clauses)
 	{
-		int			attnum = lfirst_int(lc);
+		int			attphysnum = lfirst_int(lc);
 
 		result <<= 1;
 
-		if (!bms_is_member(attnum, grouped_cols))
+		if (!bms_is_member(attphysnum, grouped_cols))
 			result |= 1;
 	}
 
@@ -4303,7 +4303,7 @@ ExecEvalSysVar(ExprState *state, ExprEvalStep *op, ExprContext *econtext,
 
 	/* slot_getsysattr has sufficient defenses against bad attnums */
 	d = slot_getsysattr(slot,
-						op->d.var.attnum,
+						op->d.var.attphysnum,
 						op->resnull);
 	*op->resvalue = d;
 	/* this ought to be unreachable, but it's cheap enough to check */
diff --git a/src/backend/executor/execMain.c b/src/backend/executor/execMain.c
index ef2fd46092..045c25e634 100644
--- a/src/backend/executor/execMain.c
+++ b/src/backend/executor/execMain.c
@@ -2264,9 +2264,9 @@ ExecBuildSlotValueDescription(Oid reloid,
 			 * for the column.  If not, omit this column from the error
 			 * message.
 			 */
-			aclresult = pg_attribute_aclcheck(reloid, att->attnum,
+			aclresult = pg_attribute_aclcheck(reloid, att->attphysnum,
 											  GetUserId(), ACL_SELECT);
-			if (bms_is_member(att->attnum - FirstLowInvalidHeapAttributeNumber,
+			if (bms_is_member(att->attphysnum - FirstLowInvalidHeapAttributeNumber,
 							  modifiedCols) || aclresult == ACLCHECK_OK)
 			{
 				column_perm = any_perm = true;
diff --git a/src/backend/executor/execPartition.c b/src/backend/executor/execPartition.c
index e03ea27299..507212a9a8 100644
--- a/src/backend/executor/execPartition.c
+++ b/src/backend/executor/execPartition.c
@@ -1471,15 +1471,15 @@ ExecBuildSlotPartitionKeyDescription(Relation rel,
 		 */
 		for (i = 0; i < partnatts; i++)
 		{
-			AttrNumber	attnum = get_partition_col_attnum(key, i);
+			AttrNumber	attphysnum = get_partition_col_attnum(key, i);
 
 			/*
 			 * If this partition key column is an expression, we return no
 			 * detail rather than try to figure out what column(s) the
 			 * expression includes and if the user has SELECT rights on them.
 			 */
-			if (attnum == InvalidAttrNumber ||
-				pg_attribute_aclcheck(relid, attnum, GetUserId(),
+			if (attphysnum == InvalidAttrNumber ||
+				pg_attribute_aclcheck(relid, attphysnum, GetUserId(),
 									  ACL_SELECT) != ACLCHECK_OK)
 				return NULL;
 		}
diff --git a/src/backend/executor/execTuples.c b/src/backend/executor/execTuples.c
index 06ac253ea0..c94f45491f 100644
--- a/src/backend/executor/execTuples.c
+++ b/src/backend/executor/execTuples.c
@@ -137,7 +137,7 @@ tts_virtual_getsomeattrs(TupleTableSlot *slot, int natts)
  * here, but provide a user-friendly message if we do.
  */
 static Datum
-tts_virtual_getsysattr(TupleTableSlot *slot, int attnum, bool *isnull)
+tts_virtual_getsysattr(TupleTableSlot *slot, int attphysnum, bool *isnull)
 {
 	Assert(!TTS_EMPTY(slot));
 
@@ -337,7 +337,7 @@ tts_heap_getsomeattrs(TupleTableSlot *slot, int natts)
 }
 
 static Datum
-tts_heap_getsysattr(TupleTableSlot *slot, int attnum, bool *isnull)
+tts_heap_getsysattr(TupleTableSlot *slot, int attphysnum, bool *isnull)
 {
 	HeapTupleTableSlot *hslot = (HeapTupleTableSlot *) slot;
 
@@ -352,7 +352,7 @@ tts_heap_getsysattr(TupleTableSlot *slot, int attnum, bool *isnull)
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 				 errmsg("cannot retrieve a system column in this context")));
 
-	return heap_getsysattr(hslot->tuple, attnum,
+	return heap_getsysattr(hslot->tuple, attphysnum,
 						   slot->tts_tupleDescriptor, isnull);
 }
 
@@ -512,7 +512,7 @@ tts_minimal_getsomeattrs(TupleTableSlot *slot, int natts)
 }
 
 static Datum
-tts_minimal_getsysattr(TupleTableSlot *slot, int attnum, bool *isnull)
+tts_minimal_getsysattr(TupleTableSlot *slot, int attphysnum, bool *isnull)
 {
 	Assert(!TTS_EMPTY(slot));
 
@@ -696,7 +696,7 @@ tts_buffer_heap_getsomeattrs(TupleTableSlot *slot, int natts)
 }
 
 static Datum
-tts_buffer_heap_getsysattr(TupleTableSlot *slot, int attnum, bool *isnull)
+tts_buffer_heap_getsysattr(TupleTableSlot *slot, int attphysnum, bool *isnull)
 {
 	BufferHeapTupleTableSlot *bslot = (BufferHeapTupleTableSlot *) slot;
 
@@ -711,7 +711,7 @@ tts_buffer_heap_getsysattr(TupleTableSlot *slot, int attnum, bool *isnull)
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 				 errmsg("cannot retrieve a system column in this context")));
 
-	return heap_getsysattr(bslot->base.tuple, attnum,
+	return heap_getsysattr(bslot->base.tuple, attphysnum,
 						   slot->tts_tupleDescriptor, isnull);
 }
 
@@ -930,7 +930,7 @@ slot_deform_heap_tuple(TupleTableSlot *slot, HeapTuple tuple, uint32 *offp,
 	bool	   *isnull = slot->tts_isnull;
 	HeapTupleHeader tup = tuple->t_data;
 	bool		hasnulls = HeapTupleHasNulls(tuple);
-	int			attnum;
+	int			attphysnum;
 	char	   *tp;				/* ptr to tuple data */
 	uint32		off;			/* offset in tuple data */
 	bits8	   *bp = tup->t_bits;	/* ptr to null bitmap in tuple */
@@ -943,8 +943,8 @@ slot_deform_heap_tuple(TupleTableSlot *slot, HeapTuple tuple, uint32 *offp,
 	 * Check whether the first call for this tuple, and initialize or restore
 	 * loop state.
 	 */
-	attnum = slot->tts_nvalid;
-	if (attnum == 0)
+	attphysnum = slot->tts_nvalid;
+	if (attphysnum == 0)
 	{
 		/* Start from the first attribute */
 		off = 0;
@@ -959,19 +959,19 @@ slot_deform_heap_tuple(TupleTableSlot *slot, HeapTuple tuple, uint32 *offp,
 
 	tp = (char *) tup + tup->t_hoff;
 
-	for (; attnum < natts; attnum++)
+	for (; attphysnum < natts; attphysnum++)
 	{
-		Form_pg_attribute thisatt = TupleDescAttr(tupleDesc, attnum);
+		Form_pg_attribute thisatt = TupleDescAttr(tupleDesc, attphysnum);
 
-		if (hasnulls && att_isnull(attnum, bp))
+		if (hasnulls && att_isnull(attphysnum, bp))
 		{
-			values[attnum] = (Datum) 0;
-			isnull[attnum] = true;
+			values[attphysnum] = (Datum) 0;
+			isnull[attphysnum] = true;
 			slow = true;		/* can't use attcacheoff anymore */
 			continue;
 		}
 
-		isnull[attnum] = false;
+		isnull[attphysnum] = false;
 
 		if (!slow && thisatt->attcacheoff >= 0)
 			off = thisatt->attcacheoff;
@@ -1002,7 +1002,7 @@ slot_deform_heap_tuple(TupleTableSlot *slot, HeapTuple tuple, uint32 *offp,
 				thisatt->attcacheoff = off;
 		}
 
-		values[attnum] = fetchatt(thisatt, tp + off);
+		values[attphysnum] = fetchatt(thisatt, tp + off);
 
 		off = att_addlength_pointer(off, thisatt->attlen, tp + off);
 
@@ -1013,7 +1013,7 @@ slot_deform_heap_tuple(TupleTableSlot *slot, HeapTuple tuple, uint32 *offp,
 	/*
 	 * Save state for next execution
 	 */
-	slot->tts_nvalid = attnum;
+	slot->tts_nvalid = attphysnum;
 	*offp = off;
 	if (slow)
 		slot->tts_flags |= TTS_FLAG_SLOW;
@@ -1899,26 +1899,26 @@ slot_getmissingattrs(TupleTableSlot *slot, int startAttNum, int lastAttNum)
  * slot_getsomeattrs_int - workhorse for slot_getsomeattrs()
  */
 void
-slot_getsomeattrs_int(TupleTableSlot *slot, int attnum)
+slot_getsomeattrs_int(TupleTableSlot *slot, int attphysnum)
 {
 	/* Check for caller errors */
-	Assert(slot->tts_nvalid < attnum);	/* checked in slot_getsomeattrs */
-	Assert(attnum > 0);
+	Assert(slot->tts_nvalid < attphysnum);	/* checked in slot_getsomeattrs */
+	Assert(attphysnum > 0);
 
-	if (unlikely(attnum > slot->tts_tupleDescriptor->natts))
-		elog(ERROR, "invalid attribute number %d", attnum);
+	if (unlikely(attphysnum > slot->tts_tupleDescriptor->natts))
+		elog(ERROR, "invalid attribute number %d", attphysnum);
 
 	/* Fetch as many attributes as possible from the underlying tuple. */
-	slot->tts_ops->getsomeattrs(slot, attnum);
+	slot->tts_ops->getsomeattrs(slot, attphysnum);
 
 	/*
 	 * If the underlying tuple doesn't have enough attributes, tuple
 	 * descriptor must have the missing attributes.
 	 */
-	if (unlikely(slot->tts_nvalid < attnum))
+	if (unlikely(slot->tts_nvalid < attphysnum))
 	{
-		slot_getmissingattrs(slot, slot->tts_nvalid, attnum);
-		slot->tts_nvalid = attnum;
+		slot_getmissingattrs(slot, slot->tts_nvalid, attphysnum);
+		slot->tts_nvalid = attphysnum;
 	}
 }
 
diff --git a/src/backend/executor/execUtils.c b/src/backend/executor/execUtils.c
index 9df1f81ea8..c5caa4e20b 100644
--- a/src/backend/executor/execUtils.c
+++ b/src/backend/executor/execUtils.c
@@ -1054,7 +1054,7 @@ GetAttributeByName(HeapTupleHeader tuple, const char *attname, bool *isNull)
 
 		if (namestrcmp(&(att->attname), attname) == 0)
 		{
-			attrno = att->attnum;
+			attrno = att->attphysnum;
 			break;
 		}
 	}
diff --git a/src/backend/executor/nodeAgg.c b/src/backend/executor/nodeAgg.c
index 139b2bd5f9..c94b3ca7cd 100644
--- a/src/backend/executor/nodeAgg.c
+++ b/src/backend/executor/nodeAgg.c
@@ -1269,10 +1269,10 @@ prepare_projection_slot(AggState *aggstate, TupleTableSlot *slot, int currentSet
 
 			foreach(lc, aggstate->all_grouped_cols)
 			{
-				int			attnum = lfirst_int(lc);
+				int			attphysnum = lfirst_int(lc);
 
-				if (!bms_is_member(attnum, grouped_cols))
-					slot->tts_isnull[attnum - 1] = true;
+				if (!bms_is_member(attphysnum, grouped_cols))
+					slot->tts_isnull[attphysnum - 1] = true;
 			}
 		}
 	}
@@ -1595,10 +1595,10 @@ find_hash_columns(AggState *aggstate)
 
 			foreach(lc, aggstate->all_grouped_cols)
 			{
-				int			attnum = lfirst_int(lc);
+				int			attphysnum = lfirst_int(lc);
 
-				if (!bms_is_member(attnum, grouped_cols))
-					colnos = bms_del_member(colnos, attnum);
+				if (!bms_is_member(attphysnum, grouped_cols))
+					colnos = bms_del_member(colnos, attphysnum);
 			}
 		}
 
diff --git a/src/backend/executor/spi.c b/src/backend/executor/spi.c
index 29bc26669b..bdc61e8925 100644
--- a/src/backend/executor/spi.c
+++ b/src/backend/executor/spi.c
@@ -1101,7 +1101,7 @@ SPI_returntuple(HeapTuple tuple, TupleDesc tupdesc)
 }
 
 HeapTuple
-SPI_modifytuple(Relation rel, HeapTuple tuple, int natts, int *attnum,
+SPI_modifytuple(Relation rel, HeapTuple tuple, int natts, int *attphysnum,
 				Datum *Values, const char *Nulls)
 {
 	MemoryContext oldcxt;
@@ -1111,7 +1111,7 @@ SPI_modifytuple(Relation rel, HeapTuple tuple, int natts, int *attnum,
 	bool	   *n;
 	int			i;
 
-	if (rel == NULL || tuple == NULL || natts < 0 || attnum == NULL || Values == NULL)
+	if (rel == NULL || tuple == NULL || natts < 0 || attphysnum == NULL || Values == NULL)
 	{
 		SPI_result = SPI_ERROR_ARGUMENT;
 		return NULL;
@@ -1137,13 +1137,13 @@ SPI_modifytuple(Relation rel, HeapTuple tuple, int natts, int *attnum,
 	/* replace values and nulls */
 	for (i = 0; i < natts; i++)
 	{
-		if (attnum[i] <= 0 || attnum[i] > numberOfAttributes)
+		if (attphysnum[i] <= 0 || attphysnum[i] > numberOfAttributes)
 			break;
-		v[attnum[i] - 1] = Values[i];
-		n[attnum[i] - 1] = (Nulls && Nulls[i] == 'n');
+		v[attphysnum[i] - 1] = Values[i];
+		n[attphysnum[i] - 1] = (Nulls && Nulls[i] == 'n');
 	}
 
-	if (i == natts)				/* no errors in *attnum */
+	if (i == natts)				/* no errors in *attphysnum */
 	{
 		mtuple = heap_form_tuple(rel->rd_att, v, n);
 
@@ -1186,7 +1186,7 @@ SPI_fnumber(TupleDesc tupdesc, const char *fname)
 
 	sysatt = SystemAttributeByName(fname);
 	if (sysatt != NULL)
-		return sysatt->attnum;
+		return sysatt->attphysnum;
 
 	/* SPI_ERROR_NOATTRIBUTE is different from all sys column numbers */
 	return SPI_ERROR_NOATTRIBUTE;
diff --git a/src/backend/foreign/foreign.c b/src/backend/foreign/foreign.c
index cf222fc3e9..c064fe50cd 100644
--- a/src/backend/foreign/foreign.c
+++ b/src/backend/foreign/foreign.c
@@ -284,20 +284,20 @@ GetForeignTable(Oid relid)
  * as list of DefElem.
  */
 List *
-GetForeignColumnOptions(Oid relid, AttrNumber attnum)
+GetForeignColumnOptions(Oid relid, AttrNumber attphysnum)
 {
 	List	   *options;
 	HeapTuple	tp;
 	Datum		datum;
 	bool		isnull;
 
-	tp = SearchSysCache2(ATTNUM,
+	tp = SearchSysCache2(ATTPHYSNUM,
 						 ObjectIdGetDatum(relid),
-						 Int16GetDatum(attnum));
+						 Int16GetDatum(attphysnum));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-			 attnum, relid);
-	datum = SysCacheGetAttr(ATTNUM,
+			 attphysnum, relid);
+	datum = SysCacheGetAttr(ATTPHYSNUM,
 							tp,
 							Anum_pg_attribute_attfdwoptions,
 							&isnull);
